/// @cond EO_CXX_EO_IMPL

inline void elm::datetime::field_limit_set(Elm_Datetime_Field_Type fieldtype_, int min_, int max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_datetime_field_limit_set(fieldtype_, min_, max_));
}

inline void elm::datetime::field_limit_get(Elm_Datetime_Field_Type fieldtype_, int* min_, int* max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_datetime_field_limit_get(fieldtype_, min_, max_));
}

inline bool elm::datetime::value_min_set(const Elm_Datetime_Time * mintime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_min_set(mintime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::datetime::value_min_get(Elm_Datetime_Time* mintime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_min_get(mintime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::datetime::value_set(const Elm_Datetime_Time * newtime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_set(newtime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::datetime::value_get(Elm_Datetime_Time* currtime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_get(currtime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::datetime::field_visible_set(Elm_Datetime_Field_Type fieldtype_, bool visible_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_datetime_field_visible_set(fieldtype_, ::efl::eolian::to_c(visible_)));
}

inline bool elm::datetime::field_visible_get(Elm_Datetime_Field_Type fieldtype_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_field_visible_get(fieldtype_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::datetime::value_max_set(const Elm_Datetime_Time * maxtime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_max_set(maxtime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::datetime::value_max_get(Elm_Datetime_Time* maxtime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_max_get(maxtime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::optional< ::efl::eina::string_view > elm::datetime::format_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_format_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::datetime::format_set(::efl::eina::optional< ::efl::eina::string_view > fmt_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_datetime_format_set(::efl::eolian::to_c(fmt_)));
}

inline void eo_cxx::elm::datetime::field_limit_set(Elm_Datetime_Field_Type fieldtype_, int min_, int max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_datetime_field_limit_set(fieldtype_, min_, max_));
}

inline void eo_cxx::elm::datetime::field_limit_get(Elm_Datetime_Field_Type fieldtype_, int* min_, int* max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_datetime_field_limit_get(fieldtype_, min_, max_));
}

inline bool eo_cxx::elm::datetime::value_min_set(const Elm_Datetime_Time * mintime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_min_set(mintime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::datetime::value_min_get(Elm_Datetime_Time* mintime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_min_get(mintime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::datetime::value_set(const Elm_Datetime_Time * newtime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_set(newtime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::datetime::value_get(Elm_Datetime_Time* currtime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_get(currtime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::datetime::field_visible_set(Elm_Datetime_Field_Type fieldtype_, bool visible_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_datetime_field_visible_set(fieldtype_, ::efl::eolian::to_c(visible_)));
}

inline bool eo_cxx::elm::datetime::field_visible_get(Elm_Datetime_Field_Type fieldtype_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_field_visible_get(fieldtype_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::datetime::value_max_set(const Elm_Datetime_Time * maxtime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_max_set(maxtime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::datetime::value_max_get(Elm_Datetime_Time* maxtime_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_value_max_get(maxtime_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::optional< ::efl::eina::string_view > eo_cxx::elm::datetime::format_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_datetime_format_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::datetime::format_set(::efl::eina::optional< ::efl::eina::string_view > fmt_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_datetime_format_set(::efl::eolian::to_c(fmt_)));
}

inline ::eo_cxx::elm::datetime::operator ::elm::datetime() const
{
   return *static_cast<::elm::datetime const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::datetime::operator ::elm::datetime&()
{
   return *static_cast<::elm::datetime*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::datetime::operator ::elm::datetime const&() const
{
   return *static_cast<::elm::datetime const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_datetime_field_limit_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Datetime_Field_Type fieldtype_, int min_, int max_)
{
   try
      {
         static_cast<T*>(self->this_)->field_limit_set(fieldtype_, min_, max_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_datetime_field_limit_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Datetime_Field_Type fieldtype_, int* min_, int* max_)
{
   try
      {
         static_cast<T*>(self->this_)->field_limit_get(fieldtype_, min_, max_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_datetime_value_min_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Datetime_Time * mintime_)
{
   try
      {
         return static_cast<T*>(self->this_)->value_min_set(mintime_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_datetime_value_min_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Datetime_Time* mintime_)
{
   try
      {
         return static_cast<T*>(self->this_)->value_min_get(mintime_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_datetime_value_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Datetime_Time * newtime_)
{
   try
      {
         return static_cast<T*>(self->this_)->value_set(newtime_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_datetime_value_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Datetime_Time* currtime_)
{
   try
      {
         return static_cast<T*>(self->this_)->value_get(currtime_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_datetime_field_visible_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Datetime_Field_Type fieldtype_, Eina_Bool visible_)
{
   try
      {
         static_cast<T*>(self->this_)->field_visible_set(fieldtype_, ::efl::eolian::to_cxx<bool>(visible_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_datetime_field_visible_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Datetime_Field_Type fieldtype_)
{
   try
      {
         return static_cast<T*>(self->this_)->field_visible_get(fieldtype_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_datetime_value_max_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Datetime_Time * maxtime_)
{
   try
      {
         return static_cast<T*>(self->this_)->value_max_set(maxtime_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_datetime_value_max_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Datetime_Time* maxtime_)
{
   try
      {
         return static_cast<T*>(self->this_)->value_max_get(maxtime_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::efl::eina::optional< ::efl::eina::string_view > elm_datetime_format_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->format_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_datetime_format_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * fmt_)
{
   try
      {
         static_cast<T*>(self->this_)->format_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(fmt_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::datetime >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
   {
      virtual void field_limit_set(Elm_Datetime_Field_Type fieldtype_, int min_, int max_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_datetime_field_limit_set(fieldtype_, min_, max_));
      }

      virtual void field_limit_get(Elm_Datetime_Field_Type fieldtype_, int* min_, int* max_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_datetime_field_limit_get(fieldtype_, min_, max_));
      }

      virtual bool value_min_set(const Elm_Datetime_Time * mintime_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_datetime_value_min_set(mintime_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool value_min_get(Elm_Datetime_Time* mintime_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_datetime_value_min_get(mintime_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool value_set(const Elm_Datetime_Time * newtime_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_datetime_value_set(newtime_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool value_get(Elm_Datetime_Time* currtime_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_datetime_value_get(currtime_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void field_visible_set(Elm_Datetime_Field_Type fieldtype_, bool visible_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_datetime_field_visible_set(fieldtype_, ::efl::eolian::to_c(visible_)));
      }

      virtual bool field_visible_get(Elm_Datetime_Field_Type fieldtype_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_datetime_field_visible_get(fieldtype_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool value_max_set(const Elm_Datetime_Time * maxtime_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_datetime_value_max_set(maxtime_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool value_max_get(Elm_Datetime_Time* maxtime_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_datetime_value_max_get(maxtime_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::efl::eina::optional< ::efl::eina::string_view > format_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_datetime_format_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void format_set(::efl::eina::optional< ::efl::eina::string_view > fmt_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_datetime_format_set(::efl::eolian::to_c(fmt_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::datetime >
{
   static constexpr int value = 
#if defined(DATETIME_PROTECTED) && defined(DATETIME_BETA)
      12
#elif defined(DATETIME_PROTECTED)
      12
#elif defined(DATETIME_BETA)
      12
#else
      12
#endif
      + operation_description_class_size<::elm::layout >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::datetime>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_field_limit_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_field_limit_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_field_limit_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_field_limit_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_value_min_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_value_min_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_value_min_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_value_min_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_value_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_value_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_value_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_value_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_field_visible_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_field_visible_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_field_visible_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_field_visible_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_value_max_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_value_max_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_value_max_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_value_max_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_format_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_format_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_datetime_format_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_datetime_format_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::datetime >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::datetime>)
{
   return (ELM_DATETIME_CLASS);
}

} } }

/// @endcond

